<script setup>
import { useThemeStore } from '@/stores/ThemeStore'
import { useLocaleStore } from '@/stores/LocaleStore'
import { useAppStore, SignInStateType } from '@/stores/AppStore'
</script>


<script>
export default {

	props: {
		title: String,
	},

	data() {
		return {
			themeStore: useThemeStore(),
			localeStore: useLocaleStore(),
			appStore: useAppStore(),
		}
	},

	methods: {
		onThemeClick(e, theme) {
			this.themeStore.change(theme)
			localStorage.setItem('theme', this.themeStore.current)
		},

		onLocaleClick(e, locale) {
			this.localeStore.change(locale)
			if (this.appStore.state === SignInStateType.AlreadySignIn) {
				this.appStore.saveLocale(locale)
			}
		},
	},

	i18n: {
		messages: {
			en: {
				dark: "Dark",
				light: "Light",
			},
			th: {
				dark: "มืด",
				light: "สว่าง",
			},
		},
	},

}
</script>


<template>
	<header>
		<div id="app-bar">
			<div id="title">{{  title ?? $t('app')  }}</div>

			<button class="icon" :title="$t('dark')" @click.prevent="(e) => onThemeClick(e, 0)">{{  $t('dark') 
				}}</button>
			<button class="icon" :title="$t('light')" @click.prevent="(e) => onThemeClick(e, 1)">{{  $t('light') 
				}}</button>

			<button class="icon" :title="$t('switchLocale.en')"
				@click.prevent="(e) => onLocaleClick(e, 'en')">EN</button>
			<button class="icon" :title="$t('switchLocale.th')"
				@click.prevent="(e) => onLocaleClick(e, 'th')">TH</button>
		</div>
	</header>
</template>


<style scoped>
header {
	position: relative;
	display: block;
	margin: 0;
	padding: 0;
	background: var(--c-page-header);
}

#app-bar {
	display: flex;
	padding: 0.75rem 1rem 0.85rem;
}

#title {
	flex: 1 0;
	margin: 0 0 0 0.5rem;
	font-size: 170%;
	color: var(--c-page-color);
}

.icon {
	flex: 0 0;
	margin: 0;
	padding: 0.5rem;
}
</style>
